from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.SimpleCartItem.config import PROJECTNAME, GLOBALS
from Products.CMFCore.permissions import ManagePortal
from Products.CMFCore.utils import getToolByName
#from Products.CMFDynamicViewFTI.migrate import migrateFTIs
from Products.SimpleCartItem.config import *
from StringIO import StringIO



def installDependencies(self):
    qi=getToolByName(self, 'portal_quickinstaller', None)
    if not qi.isProductInstalled('DataGridField'):
        qi.installProduct('DataGridField',locked=0)
        return 'DataGridField \n'





def addTypesToPortalFactory(self):
    # Add our types to the portal_factory
    factory = getToolByName(self, 'portal_factory')
    types = factory.getFactoryTypes().keys()
    new_types = []
    for t in ('SimpleCartItem',):
        if t not in types:
            types.append(t)
            new_types.append(t)
    factory.manage_setPortalFactoryTypes(listOfTypeIds = types)
    if new_types:
        return "Added %s to portal factory\n" % ','.join(new_types)
    else:
        return "Portal factory seemed to already have all the types we care about.\n"                        

def installConfiglet(self):
    """Install our simple configlet into the Plone Control Panel"""
    configlet = {
        'id': 'simplecartitem_config',
        'appId': PROJECTNAME,
        'name': 'Simple Cart Item Config',
        'action': 'string:$portal_url/prefs_simplecartitem_form',
        'category': 'Products',
        'permission': (ManagePortal,),
        'imageUrl': 'cart1_icon.gif',
    }

    self.portal_controlpanel.unregisterConfiglet(configlet['id'])
    self.portal_controlpanel.registerConfiglets((configlet,))
    return "Installed SimpleCart configlet\n"

def installPropertySheet(self):
    """Add a property sheet to save our SimpleCart settings"""
    props = getToolByName(self,'portal_properties')
    sci = getattr(props, 'simplecartitem_properties', None)
    if sci is None:
        props.manage_addPropertySheet('simplecartitem_properties', 'SimpleCartItem properties')
        sci = getattr(self.portal_properties, 'simplecartitem_properties', None)
        sci._setProperty('account_id', 'youremail@yourpaymentgateway.com', 'string')
        sci._setProperty('currency', 'USD', 'string')
        sci._setProperty('cancel_page', '/', 'string')
        sci._setProperty('thankyou_page', '/', 'string')
        return "Installed a property sheet\n"
    else:
        return "Property sheet was already installed\n"

def installPortlet(self):
    """Put our portlet in the left column"""
    slot = 'here/portlet_cart/macros/portlet'
    left_slots  = getattr(self, 'left_slots', None)
    right_slots = getattr(self, 'right_slots', None)
    if left_slots != None:
        if slot not in left_slots and slot not in right_slots:
            left_slots = list(left_slots) + [slot]
            self.left_slots = left_slots
            return "Added Cart portlet to left_slots property.\n"
        else:
            return "Cart portlet already in place -- didn't re-add.\n"
    else:
        return "left_slots property missing -- portlet not installed.\n"



def install(self):
    out = StringIO()

    installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)

    install_subskin(self, out, GLOBALS)

    out.write(installDependencies(self))
    out.write(addTypesToPortalFactory(self))
    out.write(installPropertySheet(self))
    out.write(installConfiglet(self))
    out.write(installPortlet(self))
    out.write("Successfully installed %s." % PROJECTNAME)
    
    return out.getvalue()
