from Products.CMFCore.utils import getToolByName
from StringIO import StringIO
from Products.Archetypes.public import *




def fixTypes(self):
    """Patch up old types, and convert options no need for heavy handed migrator"""
    out = StringIO()
    print >> out, "Fixing old types"
    portal_catalog = getToolByName(self, 'portal_catalog')
    brains = portal_catalog.searchResults(
                                                   Type = 'SimpleCartItem')
    for brain in brains:
        obj = brain.getObject()
        print >> out, obj.portal_type
        #set portal_type to proper item
        setattr(obj, 'portal_type',  'Cart Item')
        #since the existing options are both of a different field type and data type we have to convert
        #first extrac the old values in a format for the DataGridField
        val = [{'option':option,'price_adjustment': ''} for option in obj.getOptions()]
        #update the underlying schema so we can write to the correct field type
        obj._updateSchema()
        #write back the date to the DataGridField, converting it to the proper tuple
        obj.setOptions(tuple(val))
        print >> out,  "Updated" 
        print >> out, obj.portal_type
        print >> out, obj.absolute_url()
    
    return out.getvalue()
 
   
                       
def migrate(self):
    """Run the migration"""
    out = StringIO()
    print >> out, "Starting migration"                  
    print >> out, fixTypes(self)
    print >> out, "Migration finished"
    return out.getvalue()